<?php

namespace Drupal\monarch_symlink\Plugin\Deriver;

use Drupal\menu_link_content\Plugin\Deriver\MenuLinkContentDeriver;

/**
 * Provides a deriver for user created symlinks.
 */
class SymlinkMenuItemDeriver extends MenuLinkContentDeriver {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $entity_ids = $this->entityTypeManager->getStorage('symlink')->getQuery()
      ->accessCheck(FALSE)
      ->condition('rediscover', TRUE)
      ->execute();
    $plugin_definitions = [];
    $entities = $this->entityTypeManager->getStorage('symlink')->loadMultiple($entity_ids);

    /** @var \Drupal\monarch_symlink\SymlinkInterface $ */
    foreach ($entities as $symlink) {
      $plugin_definitions[$symlink->uuid()] = $symlink->getPluginDefinition();
    }

    return $plugin_definitions;
  }

}
